﻿using System;
using System.Collections.Generic;
using System.Text;
using VVVV.Utils.VMath;
using VVVV.Utils;

namespace VVVV.Nodes
{
    class SMTCursor : IComparable<SMTCursor>
    {
        double _x, _y;
        double _startx, _starty;
        double _startMTx, _startMTy;
        int _index, _slideindex;
        int _uniqueid;
        bool _isGoingToDie, _hitSlide;

        public SMTCursor(double x, double y, int index, int uniqueid)
        {
            _x = x;
            _y = y;
            _startx = x;
            _starty = y;

            _index = index;
            _isGoingToDie = false;
            _hitSlide = false;
            _slideindex = -1;
            _uniqueid = uniqueid;
        }

        public Vector2D xy
        {
            get
            {
                return new Vector2D(_x, _y);
            }

            set
            {
                _x = value.x;
                _y = value.y;
            }

        }

        public int index
        {
            get
            {
                return _index;
            }
        }

        public int CompareTo(SMTCursor other)
        {
            return -other.uniqueid.CompareTo(this.uniqueid);
        }

        public void youMightDie()
        {
            // every frame, possibly this frame might die
            // set variable to true to say this might happen
            _isGoingToDie = true;
        }

        public bool isGoingToDie
        {
            get
            {
                return _isGoingToDie;
            }
            set
            {
                _isGoingToDie = value;
            }
        }

        public bool hitSlide
        {
            get
            {
                return _hitSlide;
            }
            set
            {
                _hitSlide = value;
            }
        }

        public bool isID(int inID)
        {
            return (inID == _index);
        }

        public bool isID(double inID)
        {
            return (System.Convert.ToInt32(inID) == _index);
        }

        public int slideindex
        {
            get
            {
                return _slideindex;
            }
            set
            {
                _slideindex = value;
            }
        }

        public Vector2D deltaxy
        {
            get
            {
                return new Vector2D(_x-_startx, _y-_starty);
            }
        }

        public Vector2D startxy
        {
            get
            {
                return new Vector2D(_startx, _starty);
            }
        }

        public Vector2D startMTxy
        {
            get
            {
                return new Vector2D(_startMTx, _startMTy);
            }
            set
            {
                _startMTx = value.x;
                _startMTy = value.y;
            }
        }

        public void startMT()
        {
            _startMTx = _x;
            _startMTy = _y;
        }

        public int uniqueid
        {
            get
            {
                return _uniqueid;
            }
            set
            {
                _uniqueid = value;
            }
        }


    }
}
